'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

exports.default = Email;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Link = require('./Link');

var _Link2 = _interopRequireDefault(_Link);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @copyright   2016, Miles Johnson
 * @license     https://opensource.org/licenses/MIT
 * 
 */

/*:: import type { EmailProps } from '../types';*/


function obfuscate(email /*: string*/) /*: string*/ {
  var scrambled = '';

  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = (0, _getIterator3.default)(email), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var char = _step.value;

      scrambled += '&#' + char.charCodeAt(0) + ';';
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return scrambled;
}

function Email(_ref) {
  var children = _ref.children;
  var _ref$obfuscateEmail = _ref.obfuscateEmail;
  var obfuscateEmail = _ref$obfuscateEmail === undefined ? false : _ref$obfuscateEmail;
  var props = (0, _objectWithoutProperties3.default)(_ref, ['children', 'obfuscateEmail']);

  var email = children;
  var mailTo = 'mailto';

  if (obfuscateEmail) {
    email = obfuscate(email);
    mailTo = obfuscate(mailTo);
  }

  return _react2.default.createElement(
    _Link2.default,
    (0, _extends3.default)({}, props, { href: mailTo + ':' + email }),
    email
  );
}

Email.propTypes = {
  children: _react.PropTypes.string.isRequired,
  obfuscateEmail: _react.PropTypes.bool,
  emailParts: _react.PropTypes.shape({
    username: _react.PropTypes.string,
    host: _react.PropTypes.string
  })
};